// Copyright (1995) by melonSoft Ralf Suckow Berlin, All Rights Reserved

#import <appkit/appkit.h>
#import "MLProductionProtocols.h"

@interface MLPluckMaster : Object  <MLVoiceProduction>
{
  id  positionField;
  id  attenuationField;
  id  frequencyField;
  id  durationFactorField;
  id  volumeField;
  id  durationField;
}

- appDidInit:sender;
- showError:(const char *)text with:(const char *)parameter;

- getPosition:(double *)position attenuation:(double *)attenuation
  durationFactor:(double *)durationFactor fromFile:(const char *)inputFile;

- (double)getParameter:(const char *)name
  default:(double)defaultValue from:params;
- restrict:(double *)value toMin:(double)min max:(double)max;

- (BOOL)makeFile:(const char *)outputFile
  withFrequency:(double)frequency volume:(double)volume
  duration:(double)duration position:(double)position
  attenuation:(double)attenuation durationFactor:(double)durationFactor;

- (BOOL)makeFile:(const char *)outputFile
  fromVoice:(const char *)inputFile parameters:params;

- (BOOL)appAcceptsAnotherFile:sender;
- (int)app:sender openFile:(const char *)path type:(const char *)type;
//- doOpen:path;

- saveSound:sender;
- saveSettings:sender;
- play:sender;

@end

// the following method is implemented in MLPluckAlgorithm.m

@interface MLPluckMaster (Algorithm)

// allocate buf (with malloc), fill it, and return the number of samples
- (int)calculateSamples:(short int **)buf
  withFrequency:(double)frequency volume:(double)volume
  duration:(double)duration position:(double)position
  attenuation:(double)attenuation durationFactor:(double)durationFactor;

@end
